%global debug_package   %{nil}

%global provider_tld    com
%global provider        github
%global project         danielqsj
%global repo            kafka_exporter
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          0d5d4ac4ba63948748cc2c53b35ed95c310cd6f2
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

%global reltag redhat_00001
%global namedreltag -redhat-00001
%global namedversion %{version}%{namedreltag}

%ifarch aarch64
%global aId kafka_exporter-linux-aarch64
%endif
%ifarch ppc64le
%global aId kafka_exporter-linux-ppc64le
%endif
%ifarch s390x
%global aId kafka_exporter-linux-s390x
%endif
%ifarch x86_64
%global aId kafka_exporter-linux-x86_64
%endif
%global repolibdir %{_javadir}/repository.jboss.com/maven2-brew/com/github/danielqsj/%{aId}/%{namedversion}


Name:           golang-%{provider}-%{project}-%{repo}
Summary:        Kafka exporter for Prometheus
Version:        1.4.2
Release:        2.%{?reltag}%{?dist}
License:        ASL 2.0
URL:            https://%{provider_prefix}

#Source0:        https://%%{provider_prefix}/archive/v%%{version}/%%{repo}-%%{version}.tar.gz
Source0:        https://%%{provider_prefix}/archive/%%{commit}/%%{repo}-%%{commit}.tar.gz
Source1:        kafka_exporter.pom

# Fix for CVE-2022-21698, see patch file header for more info
Patch0:         0001-Update-prometheus-client_golang-to-v1.11.1.patch

# https://github.com/danielqsj/kafka_exporter/pull/291
Patch1:         0002-Fix-number-of-workers-when-we-have-less-than-2-topic.patch

BuildRequires:  golang >= 1.17.7
BuildRequires:  prometheus-promu
BuildRequires:  zip

%if 0%{?rhel} && 0%{?rhel} < 8
# go-toolset-1.16 is not built for aarch64
ExclusiveArch:  x86_64 ppc64le s390x
%else
ExclusiveArch:  %{go_arches}
%endif

%description
%{summary}.

%package -n kafka_exporter
Summary:        Kafka exporter for Prometheus

%description -n kafka_exporter
%{summary}.

%package repolib
Summary:        Artifacts to be uploaded to a repository library

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.

%prep
# promu names the binary according to the working directory
%setup -q -c -n kafka_exporter
pushd kafka_exporter-%{commit}
%patch0 -p1
%patch1 -p1
popd

# dot-files (particularly .promu.yml) must be moved too
mv kafka_exporter-%{commit}/* kafka_exporter-%{commit}/.[!.]* .

%build
promu build
zip kafka_exporter.zip kafka_exporter

%install

%ifarch aarch64
archdir=linux-aarch64
%endif
%ifarch ppc64le
archdir=linux-ppc64le
%endif
%ifarch s390x
archdir=linux-s390x
%endif
%ifarch x86_64
archdir=linux-x86_64
%endif

install -D -m 755 kafka_exporter $RPM_BUILD_ROOT%{_bindir}/kafka_exporter

# repolib
install -d -m 755 $RPM_BUILD_ROOT%{repolibdir}
cp -p kafka_exporter.zip $RPM_BUILD_ROOT%{repolibdir}/kafka_exporter-$archdir-%{namedversion}.zip
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{repolibdir}/%{aId}-%{namedversion}.pom
sed -i -e 's:@@@VERSION@@@:%{namedversion}:' -e 's:@@@ARTIFACTID@@@:%{aId}:' $RPM_BUILD_ROOT%{repolibdir}/%{aId}-%{namedversion}.pom

%check
go test %{import_path}

%files -n kafka_exporter
%license LICENSE
%doc README.md
%{_bindir}/kafka_exporter

%files repolib
%{_javadir}/repository.jboss.com/maven2-brew/*


%changelog
* Fri Jul 01 2022 Gerard Ryan <gryan@redhat.com> - 1.4.2-2.redhat_00001
- Upgrade prometheus/client_golang dependency to v1.11.1

* Thu Feb 10 2022 Kyle Liberti <kliberti@redhat.com> - 1.4.2-1.redhat_00002
- Rebuilt for shipping to s390x and aarch product listings

* Wed Sep 01 2021 Yaakov Selkowitz <yselkowi@redhat.com> - 1.3.1-3.redhat_00003
- Rebuilt for RHEL 8

* Tue Aug 24 2021 Yaakov Selkowitz <yselkowi@redhat.com> 1.3.1-1.redhat_00002
- Initial build
